package se.softstuff.nb.nbtranslate.editor;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.util.Collection;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import org.openide.DialogDescriptor;
import org.openide.DialogDisplayer;
import org.openide.util.editable.NbBundle;
import org.openide.util.editable.NbResourceBundler;
import se.softstuff.nb.nbtranslate.data.NbTranslation;
import se.softstuff.nb.nbtranslate.marker.GlassUtil;
import se.softstuff.nb.nbtranslate.swing.ColumnRenderer;
import se.softstuff.nb.nbtranslate.swing.DynamicTableModel;

/**
 *
 * @author stefan
 */
public class ComponentEditorPanel extends javax.swing.JPanel implements ListSelectionListener {

    public static void edit(MouseEvent mouseEvent) {

        NbTranslation translation = NbBundleEditManager.getInstance().getTranslation();

        Component component = GlassUtil.findComponentUnderGlassPaneAt(mouseEvent);

        NbResourceBundler bundler = NbBundle.getBundler();
        if (!(bundler instanceof EditableBundler)) {
            return;
        }

        EditableBundler editableBundler = (EditableBundler) bundler;

        ComponentEditorPanel editor = new ComponentEditorPanel(component, translation, editableBundler);

        showCloseDialog(editor);

    }

    private static void showCloseDialog(JPanel editor) {
        JButton closeButton = new CloseButton();

        Object[] options = new Object[1];
        options[0] = closeButton;

        DialogDescriptor nd = new DialogDescriptor(
                editor,
                "Localize text",
                true,
                options,
                closeButton,
                DialogDescriptor.DEFAULT_ALIGN,
                null,
                null);

        nd.setClosingOptions(new Object[]{closeButton});


        DialogDisplayer.getDefault().notify(nd);
    }
    private ComponentEditorPresentationModel model;

    private DynamicTableModel tableModel;

    private DynamicTableModel languageTableModel;

    /**
     * Creates new form ComponentEditorPanel
     */
    public ComponentEditorPanel(Component componentToTranslate, NbTranslation translation, EditableBundler editableBundler) {

        tableModel = new DynamicTableModel();
        languageTableModel = new DynamicTableModel();
        model = new ComponentEditorPresentationModel();

        initComponents();

        initResultTableColumns();
        initLanguageTableColumns();



        model.init(componentToTranslate, translation, editableBundler);

        String text = model.findComponentText(componentToTranslate);
        String componentName = componentToTranslate.getName();
        if(text == null){
            setCompTextTextField.setEnabled(false);
            setCompTextButton.setEnabled(false);
            nameSearchTextField.setText("");
        } else {
            setTextToComponentFiald(text);
            nameSearchTextField.setText(componentName);
            textSearchTextField.setText(text);
        }
        this.resultTable.getSelectionModel().addListSelectionListener(this);
        this.jTable1.getSelectionModel().addListSelectionListener(this);

        search();

    }

    public ComponentEditorPanel() {
        initComponents();
    }

    public final void search() {
        String nameSearch = nameSearchTextField.getText();
        String textSearch = textSearchTextField.getText();

        List<SearchElementResultRow> rows = model.search(nameSearch, textSearch);

        tableModel.setRows(rows);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        setCompTextTextField = new javax.swing.JTextField();
        compTextLabel = new javax.swing.JLabel();
        setCompTextLabel = new javax.swing.JLabel();
        textSearchTextField = new javax.swing.JTextField();
        setCompTextButton = new javax.swing.JButton();
        searchButton = new javax.swing.JButton();
        compNameLabel = new javax.swing.JLabel();
        nameSearchTextField = new javax.swing.JTextField();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        resultTable = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        setName("Form"); // NOI18N

        jPanel2.setName("jPanel2"); // NOI18N

        jPanel4.setName("jPanel4"); // NOI18N

        setCompTextTextField.setName("setCompTextTextField"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(compTextLabel, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.compTextLabel.text")); // NOI18N
        compTextLabel.setName("compTextLabel"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(setCompTextLabel, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.setCompTextLabel.text")); // NOI18N
        setCompTextLabel.setName("setCompTextLabel"); // NOI18N

        textSearchTextField.setName("textSearchTextField"); // NOI18N
        textSearchTextField.setNextFocusableComponent(searchButton);
        textSearchTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textSearchTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(setCompTextButton, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.setCompTextButton.text")); // NOI18N
        setCompTextButton.setName("setCompTextButton"); // NOI18N
        setCompTextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setCompTextButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(searchButton, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.searchButton.text")); // NOI18N
        searchButton.setName("searchButton"); // NOI18N
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(compNameLabel, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.compNameLabel.text")); // NOI18N
        compNameLabel.setName("compNameLabel"); // NOI18N

        nameSearchTextField.setName("nameSearchTextField"); // NOI18N
        nameSearchTextField.setNextFocusableComponent(searchButton);
        nameSearchTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nameSearchTextFieldActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(compTextLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(compNameLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(textSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nameSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(searchButton))
                    .addComponent(setCompTextLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(setCompTextTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(setCompTextButton)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(compTextLabel)
                    .addComponent(compNameLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(nameSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(setCompTextLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(setCompTextTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(setCompTextButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setName("jSplitPane1"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.jLabel1.text_1")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        resultTable.setModel(tableModel);
        resultTable.setName("resultTable"); // NOI18N
        resultTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(resultTable);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                .addContainerGap())
        );

        jSplitPane1.setTopComponent(jPanel1);

        jPanel3.setName("jPanel3"); // NOI18N

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jTable1.setModel(languageTableModel);
        jTable1.setName("jTable1"); // NOI18N
        jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane2.setViewportView(jTable1);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.jLabel3.text_1")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 278, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 225, Short.MAX_VALUE)
                .addContainerGap())
        );

        jSplitPane1.setBottomComponent(jPanel3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 473, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void textSearchTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textSearchTextFieldActionPerformed
        search();
    }//GEN-LAST:event_textSearchTextFieldActionPerformed

    private void nameSearchTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nameSearchTextFieldActionPerformed
        search();
    }//GEN-LAST:event_nameSearchTextFieldActionPerformed

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        search();
    }//GEN-LAST:event_searchButtonActionPerformed

    private void setCompTextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setCompTextButtonActionPerformed
        String newText = setCompTextTextField.getText().replaceAll("&", "");
        model.setComponentText(newText);
    }//GEN-LAST:event_setCompTextButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel compNameLabel;
    private javax.swing.JLabel compTextLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField nameSearchTextField;
    private javax.swing.JTable resultTable;
    private javax.swing.JButton searchButton;
    private javax.swing.JButton setCompTextButton;
    private javax.swing.JLabel setCompTextLabel;
    private javax.swing.JTextField setCompTextTextField;
    private javax.swing.JTextField textSearchTextField;
    // End of variables declaration//GEN-END:variables

    private void initResultTableColumns() {
        ColumnRenderer keyColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.key.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getKey();
            }
        };
        ColumnRenderer originalColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.original.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getOriginal();
            }
        };
        ColumnRenderer valueColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.value.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getValue();
            }

            @Override
            public boolean isCellEditable(SearchElementResultRow row) {
                return true;
            }

            @Override
            public void setValueAt(SearchElementResultRow row, String newValue) {
                model.editRow(row, newValue);
                setTextToComponentFiald(newValue);
            }
        };

        ColumnRenderer langColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.language.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getLanguage();
            }
        };
        ColumnRenderer moduleColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.module.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getModule();
            }
        };

        ColumnRenderer resouceColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.resouce.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getResource();
            }
        };

        this.tableModel.addColumn(langColumn, originalColumn, valueColumn, keyColumn, moduleColumn, resouceColumn);

    }

    private void initLanguageTableColumns() {

        ColumnRenderer valueColumn = new ColumnRenderer<LanguageRowModel, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.LanguageRowModel.value.column.header");
            }

            @Override
            public String render(LanguageRowModel row) {
                return row.getNewValue();
            }

            @Override
            public boolean isCellEditable(LanguageRowModel row) {
                return true;
            }

            @Override
            public void setValueAt(LanguageRowModel row, String newValue) {
                model.editLanguageRow(row, newValue);
                setTextToComponentFiald(newValue);

            }
        };


        languageTableModel.addColumn(LanguageRowModel.createLanguageColumn(), LanguageRowModel.createStandardValueColumn(), valueColumn, LanguageRowModel.createKeyColumn(), LanguageRowModel.createResourceColumn(), LanguageRowModel.createModuleColumn());
    }

    @Override
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting()) {
            return;
        }
        if(e.getSource() == resultTable.getSelectionModel()) {
            int selectedRow = resultTable.getSelectedRow();
            SearchElementResultRow row = (SearchElementResultRow) tableModel.getRow(selectedRow);
            if (row == null) {
                languageTableModel.clear();
            } else {
                Collection<LanguageRowModel> rows = model.findLanguageRowsFor(row);
                languageTableModel.setRows(rows);
                setTextToComponentFiald(row.getValue());
            }
        } else if(e.getSource() == jTable1.getSelectionModel()) {
            int selectedRow = jTable1.getSelectedRow();
            LanguageRowModel row = (LanguageRowModel) this.languageTableModel.getRow(selectedRow);
            if (row != null) {
                setTextToComponentFiald(row.getNewValue());
            }
        }
    }

    private void setTextToComponentFiald(String text){
        if(!setCompTextTextField.isEnabled()){
           return;
        }

        if(text == null){
            text = "";
        }
        text = text.replaceAll("&", "");
        setCompTextTextField.setText(text);
    }

    private static class CloseButton extends JButton {

        {
            setText(NbBundle.getMessage(CloseButton.class, "CloseButton.text"));
        }
    }
}
